export declare class Schema {
    __?: any;
}
declare class DomainSchema extends Schema {
    static ID: {
        new (value?: any): {
            readonly [index: number]: string;
            toString(): string;
            charAt(pos: number): string;
            charCodeAt(index: number): number;
            concat(...strings: string[]): string;
            indexOf(searchString: string, position?: number): number;
            lastIndexOf(searchString: string, position?: number): number;
            localeCompare(that: string): number;
            localeCompare(that: string, locales?: string | string[], options?: Intl.CollatorOptions): number;
            match(regexp: string | RegExp): RegExpMatchArray;
            match(matcher: {
                [Symbol.match](string: string): RegExpMatchArray;
            }): RegExpMatchArray;
            replace(searchValue: string | RegExp, replaceValue: string): string;
            replace(searchValue: string | RegExp, replacer: (substring: string, ...args: any[]) => string): string;
            replace(searchValue: {
                [Symbol.replace](string: string, replaceValue: string): string;
            }, replaceValue: string): string;
            replace(searchValue: {
                [Symbol.replace](string: string, replacer: (substring: string, ...args: any[]) => string): string;
            }, replacer: (substring: string, ...args: any[]) => string): string;
            search(regexp: string | RegExp): number;
            search(searcher: {
                [Symbol.search](string: string): number;
            }): number;
            slice(start?: number, end?: number): string;
            split(separator: string | RegExp, limit?: number): string[];
            split(splitter: {
                [Symbol.split](string: string, limit?: number): string[];
            }, limit?: number): string[];
            substring(start: number, end?: number): string;
            toLowerCase(): string;
            toLocaleLowerCase(): string;
            toUpperCase(): string;
            toLocaleUpperCase(): string;
            trim(): string;
            readonly length: number;
            substr(from: number, length?: number): string;
            valueOf(): string;
            [Symbol.iterator](): IterableIterator<string>;
            codePointAt(pos: number): number;
            includes(searchString: string, position?: number): boolean;
            endsWith(searchString: string, endPosition?: number): boolean;
            normalize(form: "NFC" | "NFD" | "NFKC" | "NFKD"): string;
            normalize(form?: string): string;
            repeat(count: number): string;
            startsWith(searchString: string, position?: number): boolean;
            anchor(name: string): string;
            big(): string;
            blink(): string;
            bold(): string;
            fixed(): string;
            fontcolor(color: string): string;
            fontsize(size: number): string;
            fontsize(size: string): string;
            italics(): string;
            link(url: string): string;
            small(): string;
            strike(): string;
            sub(): string;
            sup(): string;
        };
        fromCharCode(...codes: number[]): string;
        fromCodePoint(...codePoints: number[]): string;
        raw(template: TemplateStringsArray, ...substitutions: any[]): string;
    };
    static Int: {
        new (value?: any): {
            toString(radix?: number): string;
            toFixed(fractionDigits?: number): string;
            toExponential(fractionDigits?: number): string;
            toPrecision(precision?: number): string;
            valueOf(): number;
            toLocaleString(locales?: string | string[], options?: Intl.NumberFormatOptions): string;
        };
        readonly MAX_VALUE: number;
        readonly MIN_VALUE: number;
        readonly NaN: number;
        readonly NEGATIVE_INFINITY: number;
        readonly POSITIVE_INFINITY: number;
        readonly EPSILON: number;
        isFinite(number: number): boolean;
        isInteger(number: number): boolean;
        isNaN(number: number): boolean;
        isSafeInteger(number: number): boolean;
        readonly MAX_SAFE_INTEGER: number;
        readonly MIN_SAFE_INTEGER: number;
        parseFloat(string: string): number;
        parseInt(string: string, radix?: number): number;
    };
    static Float: {
        new (value?: any): {
            toString(radix?: number): string;
            toFixed(fractionDigits?: number): string;
            toExponential(fractionDigits?: number): string;
            toPrecision(precision?: number): string;
            valueOf(): number;
            toLocaleString(locales?: string | string[], options?: Intl.NumberFormatOptions): string;
        };
        readonly MAX_VALUE: number;
        readonly MIN_VALUE: number;
        readonly NaN: number;
        readonly NEGATIVE_INFINITY: number;
        readonly POSITIVE_INFINITY: number;
        readonly EPSILON: number;
        isFinite(number: number): boolean;
        isInteger(number: number): boolean;
        isNaN(number: number): boolean;
        isSafeInteger(number: number): boolean;
        readonly MAX_SAFE_INTEGER: number;
        readonly MIN_SAFE_INTEGER: number;
        parseFloat(string: string): number;
        parseInt(string: string, radix?: number): number;
    };
    static Time: {
        new (): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: number): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: string): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: Date): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        parse(s: string): number;
        UTC(year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): number;
        now(): number;
    };
    static DateTime: {
        new (): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: number): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: string): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        new (value: Date): {
            toString(): string;
            toDateString(): string;
            toTimeString(): string;
            toLocaleString(): string;
            toLocaleString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleDateString(): string;
            toLocaleDateString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            toLocaleTimeString(): string;
            toLocaleTimeString(locales?: string | string[], options?: Intl.DateTimeFormatOptions): string;
            valueOf(): number;
            getTime(): number;
            getFullYear(): number;
            getUTCFullYear(): number;
            getMonth(): number;
            getUTCMonth(): number;
            getDate(): number;
            getUTCDate(): number;
            getDay(): number;
            getUTCDay(): number;
            getHours(): number;
            getUTCHours(): number;
            getMinutes(): number;
            getUTCMinutes(): number;
            getSeconds(): number;
            getUTCSeconds(): number;
            getMilliseconds(): number;
            getUTCMilliseconds(): number;
            getTimezoneOffset(): number;
            setTime(time: number): number;
            setMilliseconds(ms: number): number;
            setUTCMilliseconds(ms: number): number;
            setSeconds(sec: number, ms?: number): number;
            setUTCSeconds(sec: number, ms?: number): number;
            setMinutes(min: number, sec?: number, ms?: number): number;
            setUTCMinutes(min: number, sec?: number, ms?: number): number;
            setHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setUTCHours(hours: number, min?: number, sec?: number, ms?: number): number;
            setDate(date: number): number;
            setUTCDate(date: number): number;
            setMonth(month: number, date?: number): number;
            setUTCMonth(month: number, date?: number): number;
            setFullYear(year: number, month?: number, date?: number): number;
            setUTCFullYear(year: number, month?: number, date?: number): number;
            toUTCString(): string;
            toISOString(): string;
            toJSON(key?: any): string;
            [Symbol.toPrimitive](hint: "default"): string;
            [Symbol.toPrimitive](hint: "string"): string;
            [Symbol.toPrimitive](hint: "number"): number;
            [Symbol.toPrimitive](hint: string): string | number;
        };
        parse(s: string): number;
        UTC(year: number, month: number, date?: number, hours?: number, minutes?: number, seconds?: number, ms?: number): number;
        now(): number;
    };
    private _schemaClass;
    private _schema;
    private _values;
    constructor(clazz: any, _defs?: any);
    readonly isSchema: boolean;
    readonly __: any;
    readonly values: any;
    keys(): string[];
    readonly name: string;
    readonly schema: Schema;
    private static _throwWrongSchema(clazz);
    private _normalizeValues(_defs);
    private static _isSchema(clazz);
    private static _isConstructable(f);
}
export default DomainSchema;
