"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Schema = (function () {
    function Schema() {
    }
    return Schema;
}());
exports.Schema = Schema;
var DomainSchema = (function (_super) {
    __extends(DomainSchema, _super);
    function DomainSchema(clazz, _defs) {
        var _this = _super.call(this) || this;
        if (clazz instanceof DomainSchema) {
            _this._schemaClass = clazz._schemaClass;
            _this._schema = clazz._schema;
            _this._values = clazz._values;
        }
        else if (!DomainSchema._isConstructable(clazz)) {
            DomainSchema._throwWrongSchema(clazz);
        }
        else {
            _this._schemaClass = clazz;
            _this._schema = new clazz();
            _this._values = _this._normalizeValues(__assign({}, _defs, (_a = {}, _a[clazz] = _this, _a)));
            if (!(_this._schema instanceof Schema)) {
                DomainSchema._throwWrongSchema(clazz);
            }
        }
        return _this;
        var _a;
    }
    Object.defineProperty(DomainSchema.prototype, "isSchema", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainSchema.prototype, "__", {
        get: function () {
            return this._schema.__ || {};
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainSchema.prototype, "values", {
        get: function () {
            return this._values;
        },
        enumerable: true,
        configurable: true
    });
    DomainSchema.prototype.keys = function () {
        return Object.keys(this._values);
    };
    Object.defineProperty(DomainSchema.prototype, "name", {
        get: function () {
            return this.__.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainSchema.prototype, "schema", {
        get: function () {
            return this._schema;
        },
        enumerable: true,
        configurable: true
    });
    DomainSchema._throwWrongSchema = function (clazz) {
        throw new Error("Schema class " + (clazz ? clazz.name : clazz) + " must be an instance of Schema");
    };
    DomainSchema.prototype._normalizeValues = function (_defs) {
        var values = {};
        if (!('__' in this._schema) || !this.__.name) {
            throw new Error("Schema class " + this._schemaClass.name + " must define __.name");
        }
        for (var _i = 0, _a = Object.keys(this._schema); _i < _a.length; _i++) {
            var key = _a[_i];
            if (key === '__') {
                continue;
            }
            var value = this._schema[key];
            if (typeof value !== 'function' && value.constructor !== Array && !value.type && !value.isSchema) {
                throw new Error("'type' key is required for schema field " + this.__.name + "." + key);
            }
            else if (value.constructor === Array && value.length !== 1) {
                throw new Error("Array key " + this.__.name + "." + key + " should contain one type inside");
            }
            var def = typeof value === 'function' || value instanceof Schema || value.constructor === Array
                ? { type: value }
                : __assign({}, value);
            var type = def.type.constructor === Array ? def.type[0] : def.type;
            var targetType = DomainSchema._isSchema(type)
                ? _defs.hasOwnProperty(type) ? _defs[type] : new DomainSchema(type, _defs)
                : type;
            if (def.type.constructor === Array) {
                def.type[0] = targetType;
            }
            else {
                def.type = targetType;
            }
            values[key] = def;
        }
        return values;
    };
    DomainSchema._isSchema = function (clazz) {
        if (clazz instanceof DomainSchema) {
            return true;
        }
        else if (!DomainSchema._isConstructable(clazz)) {
            return false;
        }
        else {
            var schema = new clazz();
            return schema instanceof Schema;
        }
    };
    DomainSchema._isConstructable = function (f) {
        try {
            Reflect.construct(String, [], f);
        }
        catch (e) {
            return false;
        }
        return true;
    };
    DomainSchema.ID = (function (_super) {
        __extends(ID, _super);
        function ID() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ID;
    }(String));
    DomainSchema.Int = (function (_super) {
        __extends(Int, _super);
        function Int() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return Int;
    }(Number));
    DomainSchema.Float = (function (_super) {
        __extends(Float, _super);
        function Float() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return Float;
    }(Number));
    DomainSchema.Time = (function (_super) {
        __extends(Time, _super);
        function Time() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return Time;
    }(Date));
    DomainSchema.DateTime = (function (_super) {
        __extends(DateTime, _super);
        function DateTime() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return DateTime;
    }(Date));
    return DomainSchema;
}(Schema));
exports.default = DomainSchema;
//# sourceMappingURL=index.js.map